require 'sketchup.rb'
module VA_instantPlacer
	class VaCopyFromViewToolSelection
		def activate
			@foundSel=false
		end
		def deactivate(view)
			view.invalidate
		end
		def onMouseMove(flgs,x,y,vw)
			ph=vw.pick_helper
			ph.do_pick(x,y)
			best=ph.best_picked
			@sel=Sketchup.active_model.selection
			if best.is_a?(Sketchup::ComponentInstance)	
				@foundSel=true
				unless @sel.empty?
					@sel.clear
				end
				@sel.add(best)		
			elsif best.is_a?(Sketchup::Group)
				@foundSel=true
				unless @sel.empty?
					@sel.clear
				end
				@sel.add(best)		
			else
				@foundSel=false
				unless @sel.empty?
					@sel.clear
				end
			end
		end
		def onLButtonDown(flgs,x,y,vw)
			if @foundSel
				VA_instantPlacer.copySelection(@sel[0])
				unless @sel.empty?
					@sel.clear
				end
			else
				VA_instantPlacer.restoreView("current")
				Sketchup.active_model.select_tool(nil)
			end
		end
	end
	menuInstantPlacer=UI.menu.add_submenu("Instant Placer")
	menuInstantPlacer.add_item("Set Source View") {saveSourceView()}
	menuInstantPlacer.add_item("Copy from Source") {copyFromView(false)}
	menuInstantPlacer.add_item("Copy Multiple from Source") {copyFromView(true)}
	menuInstantPlacer.add_separator
	menuInstantPlacer.add_item("Help with Placer") {instructionsPlacer()}
	#begin
		tlBarInstantPlacer=UI::Toolbar.new("Inst PLACER")
		comd=UI::Command.new("Set Source View") {saveSourceView()}
		comd.large_icon="copyFromViewSourceLarge.jpg"
		comd.small_icon="copyFromViewSourceSmall.jpg"
		comd.tooltip="Set Source View"
		comd.status_bar_text="of Objects to copy"
		tlBarInstantPlacer.add_item(comd)
		comd=UI::Command.new("copyFromView") {copyFromView(false)}
		comd.large_icon="copyFromViewDestinationLarge.jpg"
		comd.small_icon="copyFromViewDestinationSmall.jpg"
		comd.tooltip="Make Copy"
		comd.status_bar_text="From Source View objects"
		tlBarInstantPlacer.add_item(comd)		
		comd=UI::Command.new("copyMultipleFromView") {copyFromView(true)}
		comd.large_icon="copyFromViewDestMultiLarge.jpg"
		comd.small_icon="copyFromViewDestMultiSmall.jpg"
		comd.tooltip="Make Multiple Copies"
		comd.status_bar_text="From Source View objects"
		tlBarInstantPlacer.add_item(comd)		
		status=tlBarInstantPlacer.get_last_state
		if status==1
			tlBarInstantPlacer.restore
			UI.start_timer(0.1) {tlBarInstantPlacer.restore }
		elsif status==-1
			tlBarInstantPlacer.show
		end
	#rescue
	#end
	def self.instructionsPlacer()
		ins1="In your model zoom to location where components are that you wish to use."
		ins2="Click the 'Set Source View' button."
		ins3="Navigate to where you want to place the components."
		ins4="Click the 'Copy from Source' button for a single copy or the 'Copy Multiple from Source' buttonfor multiple copies."
		ins5="The view will switch back to the source view. Select a component"
		ins6="The view will revert to the destination view. Locate the component or components"
		message="To use Placer:"+"\n\n"+ins1+"\n"+ins2+"\n"+ins3+"\n"+ins4+"\n"+ins5+"\n"+ins6
		UI.messagebox(message)
	end
	def self.copySelection(compInst)
		compDef=compInst.definition
		restoreView("current")
		Sketchup.active_model.place_component(compDef,@repeat)
	end
	def self.saveSourceView()
		viewSource=Sketchup.active_model.active_view
		cameraSource=viewSource.camera
		targetSource=cameraSource.target
		eyeSource=cameraSource.eye
		upSource=cameraSource.up
		@vaSourceViewCamera=[eyeSource,targetSource,upSource]
	end
	def self.currentView()
		viewcurrent=Sketchup.active_model.active_view
		cameraCurrent=viewcurrent.camera
		@targetCur=cameraCurrent.target
		@eyeCur=cameraCurrent.eye
		@upCur=cameraCurrent.up
	end
	def self.restoreView(which)
		newView=Sketchup.active_model.active_view
		newCamera=newView.camera
		if which=="current"
			newCamera.set(@eyeCur,@targetCur,@upCur)
		else
			newCamera.set(@vaSourceViewCamera[0],@vaSourceViewCamera[1],@vaSourceViewCamera[2])
		end
	end
	def self.copyFromView(repeat)
		@repeat=repeat
		currentView()
		restoreView("source")
		Sketchup.active_model.select_tool(VaCopyFromViewToolSelection.new)
	end

end